

enum shotgun_e
{
	SHOTGUN_IDLE = 0,
	SHOTGUN_FIRE,
	SHOTGUN_FIRE2,
	SHOTGUN_RELOAD,
	SHOTGUN_PUMP,
	SHOTGUN_START_RELOAD,
	SHOTGUN_DRAW,
	SHOTGUN_HOLSTER,
	SHOTGUN_IDLE4,
	SHOTGUN_IDLE_DEEP
};

class CMyWeapon : public CBasePlayerWeapon
{
	DECLARE_CLASS( CMyWeapon, CBasePlayerWeapon );
public:
	void Spawn( void );
	void Precache( void );
	int iItemSlot( ) { return 3; }
	int GetItemInfo(ItemInfo *p);
	int AddToPlayer( CBasePlayer *pPlayer );

	DECLARE_DATADESC();

	void PrimaryAttack( void );
	void SecondaryAttack( void );
	BOOL Deploy( );


	int m_fInReload;
	float m_flNextReload;
	int m_iShell;
};

LINK_ENTITY_TO_CLASS( weapon_my_weapon, CMyWeapon );

BEGIN_DATADESC( CMyWeapon )
	DEFINE_FIELD( m_flNextReload, FIELD_TIME ),
	DEFINE_FIELD( m_fInSpecialReload, FIELD_INTEGER ),
	DEFINE_FIELD( m_flNextReload, FIELD_TIME ),
	DEFINE_FIELD( m_flPumpTime, FIELD_TIME ),
END_DATADESC()

void CMyWeapon::Spawn( void )
{
	Precache( );
	m_iId = WEAPON_SHOTGUN;
	SET_MODEL(ENT(pev), "models/weapons/w_shotgun.mdl");

	m_iDefaultAmmo = SHOTGUN_DEFAULT_GIVE;

	FallInit();// get ready to fall
}

void CMyWeapon::Precache( void )
{
	PRECACHE_MODEL("models/weapons/v_shotgun.mdl");
	PRECACHE_MODEL("models/weapons/w_shotgun.mdl");
	PRECACHE_MODEL("models/weapons/p_shotgun.mdl");

	m_iShell = PRECACHE_MODEL ("models/weapons/shotgunshell.mdl");// shotgun shell

	PRECACHE_SOUND("items/9mmclip1.wav");              

	PRECACHE_SOUND ("weapons/dbarrel1.wav");//shotgun
	PRECACHE_SOUND ("weapons/sbarrel1.wav");//shotgun

	PRECACHE_SOUND ("weapons/reload1.wav");	// shotgun reload
	PRECACHE_SOUND ("weapons/reload3.wav");	// shotgun reload

//	PRECACHE_SOUND ("weapons/sshell1.wav");	// shotgun reload - played on client
//	PRECACHE_SOUND ("weapons/sshell3.wav");	// shotgun reload - played on client
	
	PRECACHE_SOUND ("weapons/357_cock1.wav"); // gun empty sound
	PRECACHE_SOUND ("weapons/scock1.wav");	// cock gun
}

int CMyWeapon::AddToPlayer( CBasePlayer *pPlayer )
{
	if ( CBasePlayerWeapon::AddToPlayer( pPlayer ) )
	{
		MESSAGE_BEGIN( MSG_ONE, gmsgWeapPickup, NULL, pPlayer->pev );
			WRITE_BYTE( m_iId );
		MESSAGE_END();
		return TRUE;
	}
	return FALSE;
}

int CMyWeapon::GetItemInfo(ItemInfo *p)
{
	p->pszName = STRING(pev->classname);
	p->pszAmmo1 = "buckshot";
	p->iMaxAmmo1 = BUCKSHOT_MAX_CARRY;
	p->pszAmmo2 = NULL;
	p->iMaxAmmo2 = -1;
	p->iMaxClip = SHOTGUN_MAX_CLIP;
	p->iSlot = 2;
	p->iPosition = 1;
	p->iFlags = 0;
	p->iId = m_iId = WEAPON_SHOTGUN;
	p->iWeight = SHOTGUN_WEIGHT;

	return 1;
}

BOOL CMyWeapon::Deploy( )
{
	return DefaultDeploy( "models/weapons/v_shotgun.mdl", "models/weapons/p_shotgun.mdl", SHOTGUN_DRAW, "shotgun" );
}

void CMyWeapon::PrimaryAttack(void)
{

}

void CMyWeapon::SecondaryAttack(void)
{

}